
#define _WIN32_WINNT 0x0600

#include <windows.h>
#include <winbase.h>
#include <stdlib.h>   // For _MAX_PATH definition
#include <stdio.h>
#include <malloc.h>
#include <stdint.h>

LRESULT CALLBACK WndProc (HWND, UINT, WPARAM, LPARAM);

LRESULT (* wndproc_proxy_var) (HWND, UINT, WPARAM, LPARAM) = NULL;

typedef long long int64_t;
typedef unsigned long long uint64_t;

int my_sizeof_pointer = sizeof(char *);

static void
mkcl_dynamic_callback_execute(int64_t i1, int64_t i2, int64_t i3, int64_t i4,
			      void * cbk_info, char *arg_buffer)
{
#if 1
  printf("In mkcl_dynamic_callback_execute.\n"); fflush(NULL);
#endif
  LRESULT result = WndProc((HWND) i1, (UINT) i2, (WPARAM) i3, (LPARAM) i4);

  {
    register uint64_t rax asm("rax");

    rax = result;
    return;
  }
}

static char static_buf[64] = { 0 };

void*
mkcl_dynamic_callback_make(void * data)
{
  printf("In mkcl_dynamic_callback_make().\n"); fflush(NULL);
  /*
   *	push    %rbp                    55
   *	push    %rsp                    54
   *	mov     <addr64>,%rax           48 b8 <addr64>
   *	push    %rax                    50
   *    push    %r9                     41 51           ; push arg3
   *    push    %r8                     41 50           ; push arg2
   *    push    %rdx                    52              ; push arg1
   *    push    %rcx                    51              ; push arg0
   *	mov     <addr64>,%rax           48 b8 <addr64>
   *	callq   *%rax                   48 ff d0
   *	pop     %rcx                    59
   *	pop     %rcx                    59
   *	pop     %rbp                    5d
   *	ret                             c3
   *	nop				90
   *	nop				90
   *	nop				90
   *	nop				90
   *	nop				90
   *	nop				90
   *	nop				90
   *	nop				90
   *	nop				90
   *	nop				90
   *	nop				90
   *	nop				90
   */

  /*
   * we could also adjust the SP register this way
   * instead of pushing the 4 argument registers.
   *
   *    subq    $0x20,  %rsp            48 83 EC 20
   *
   */

  /* round the size of the routine to the next I-cache line boundary (48=3*16). */
#if 1
  char * buf = static_buf;
#else
  char *buf = (char*)malloc(64);
#endif

  *(unsigned char*) (buf+0)  = 0x55;
  *(unsigned char*) (buf+1)  = 0x54;
  *(unsigned short*)(buf+2)  = 0xb848;
  *(uintptr_t*)     (buf+4)  = (uintptr_t)data;
  *(unsigned char*) (buf+12) = 0x50;
  *(unsigned short*)(buf+13) = 0x5141;
  *(unsigned short*)(buf+15) = 0x5041;
  *(unsigned char*) (buf+17) = 0x52;
  *(unsigned char*) (buf+18) = 0x51;
  *(unsigned short*)(buf+19) = 0xb848;
  *(uintptr_t*)     (buf+21) = (uintptr_t)mkcl_dynamic_callback_execute;
  *(unsigned int*)  (buf+29) = (unsigned int)0x00d0ff48;/* leading null byte is overwritten */
  *(unsigned char*) (buf+32) = 0x59;
  *(unsigned char*) (buf+33) = 0x59;
  *(unsigned char*) (buf+34) = 0x5d;
  *(unsigned char*) (buf+35) = 0xc3;
  *(unsigned long*) (buf+36) = 0x90909090;
  *(uint64_t*)(buf+40) = 0x9090909090909090LL;

  return buf;
}


static void register_wndproc_proxy(void)
{
  printf("In register_wndproc_proxy().\n"); fflush(NULL);
#if 0
  wndproc_proxy_var = WndProc;
#else
  void * cbk = mkcl_dynamic_callback_make(NULL);
  wndproc_proxy_var = cbk;
#endif
}

LRESULT CALLBACK WndProc_static_proxy(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
  printf("In WndProc_static_proxy().\n"); fflush(NULL);
  return wndproc_proxy_var(hwnd, message, wParam, lParam);
}

#if 0
extern BOOL WINAPI __declspec(dllimport) GetProcessDEPPolicy(HANDLE hProcess, LPDWORD lpFlags, PBOOL lpPermanent);
#endif

int WINAPI WinMain (HINSTANCE hInstance, HINSTANCE hpreviousInstance,
		    PSTR szCmdLine, int iCmdShow)
{
  static TCHAR szAppName[] = TEXT ("HelloWin");
  HWND hwnd;
  MSG msg;
  WNDCLASS wndclass;

  register_wndproc_proxy();

#if 1
  hInstance = GetCurrentProcess();

  HINSTANCE real_instance;
  DuplicateHandle(hInstance, hInstance, hInstance, (PHANDLE) real_instance, 0, FALSE, DUPLICATE_SAME_ACCESS);
#endif

#if 0
  {
    DWORD dep_flags = 0;
    BOOL dep_permanent = FALSE;
    BOOL ok = GetProcessDEPPolicy(real_instance, &dep_flags, &dep_permanent);

    if (!ok)
      {  printf("Failed on GetProcessDEPPolicy(). GetLastError() = %u\n", GetLastError()); fflush(NULL); }
  }
#endif


  wndclass.style = CS_HREDRAW | CS_VREDRAW;
#if 0
  wndclass.lpfnWndProc = wndproc_proxy_var;
#else
  wndclass.lpfnWndProc = WndProc_static_proxy;
#endif
  wndclass.cbClsExtra = 0;
  wndclass.cbWndExtra = 0;
#if 1
  wndclass.hInstance = real_instance;
#else
  wndclass.hInstance = hInstance;
#endif
  wndclass.hIcon = LoadIcon(NULL, IDI_APPLICATION);
  wndclass.hCursor = LoadCursor(NULL, IDC_ARROW);
  wndclass.hbrBackground = (HBRUSH) GetStockObject(WHITE_BRUSH);
  wndclass.lpszClassName = szAppName;

  printf("About to call RegisterClass().\n"); fflush(NULL);

  if (!RegisterClass(&wndclass))
    {
      MessageBox(NULL, TEXT("This program requires Windows NT!"), szAppName, MB_ICONERROR);
      return 0;
    }
  printf("Back from RegisterClass().\n"); fflush(NULL);
  hwnd = CreateWindow(szAppName,
		      TEXT("The Hello Program"),
		      WS_OVERLAPPEDWINDOW,
		      CW_USEDEFAULT,
		      CW_USEDEFAULT,
		      CW_USEDEFAULT,
		      CW_USEDEFAULT,
		      NULL,
		      NULL,
#if 0
		      hInstance,
#else
		      real_instance,
#endif
		      NULL);
  if (hwnd == NULL)
    { printf("CreateWindow() failed!\n"); fflush(NULL); return -1; }

  printf("About to call ShowWindow().\n"); fflush(NULL);
  ShowWindow(hwnd, iCmdShow);
  printf("About to call UpdateWindow().\n"); fflush(NULL);
  UpdateWindow(hwnd);

  while (GetMessage(&msg, NULL, 0, 0))
    {
      printf("+"); fflush(NULL);
      TranslateMessage(&msg);
      DispatchMessage(&msg);
    }
  return msg.wParam;
}

LRESULT CALLBACK WndProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
  HDC hdc;
  PAINTSTRUCT ps;
  RECT rect;

#if 0
  printf("In WndProc().\n"); fflush(NULL);
#endif
  switch (message)
    {
    case WM_CREATE:
      return 0;
    case WM_PAINT:
      hdc = BeginPaint(hwnd, &ps);
      GetClientRect(hwnd, &rect);
      DrawText(hdc, TEXT("Hello, Windows 98!"), -1, &rect, DT_SINGLELINE|DT_CENTER|DT_VCENTER);
      EndPaint(hwnd, &ps);
      return 0;
    case WM_DESTROY:
      PostQuitMessage(0);
      return 0;
    }
  return DefWindowProc(hwnd, message, wParam, lParam);
}
