




#+(and)
(ffi:defcallback my-compare :int ((a-ptr :pointer-void) (b-ptr :pointer-void))
  (ffi:with-cast-pointer (a-ptr :char)
    (ffi:with-cast-pointer (b-ptr :char)
      (let* ((a (ffi:deref-pointer a-ptr :char))
             (b (ffi:deref-pointer b-ptr :char))
             (val (if (char< a b) -1 (if (char= a b) 0 1))))
        ;;(format t "~&In my-compare, a-ptr = ~S, a = ~S, b-ptr = ~S, b = ~S, returning ~S.~%" a-ptr b-ptr a b val)
	(finish-output)        
        val
        )
      )
    )
  )


#-(and)
(ffi:defcallback my-compare :int ((a-ptr (* :char)) (b-ptr (* :char)))
  (format t "~&In my-compare.~%") (finish-output)
  (<= (ffi:deref-pointer a-ptr :char) (ffi:deref-pointer b-ptr :char))
  )

(ffi:def-function ("qsort" qsort)
  ((base :pointer-void) (nmemb :long) (size :long) (compar :pointer-void))
  :returning :void
  :module :default) ;; providing :module forces the use of the dynamic FFI!

(defparameter start-str "ADa1b2c3d4e5f6g7h8CB")
(defvar for-str)
(defvar result)

(setq for-str (ffi:convert-to-foreign-string start-str))

(format t "~&About to apply qsort() to this: ~S~%" (ffi:convert-from-foreign-string for-str))
(setq result (qsort for-str (length start-str) 1 (ffi:callback 'my-compare)))
(format t "~&Result of qsort() is this: ~S~%" (ffi:convert-from-foreign-string for-str))
